Index: kernel/generic/include/synch/spinlock.h
===================================================================
--- kernel/generic/include/synch/spinlock.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/synch/spinlock.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,5 @@
 /*
  * Copyright (c) 2001-2004 Jakub Jermar
+ * Copyright (c) 2023 Jiří Zárevúcky
  * All rights reserved.
  *
@@ -36,108 +37,15 @@
 #define KERN_SPINLOCK_H_
 
-#include <assert.h>
 #include <stdatomic.h>
 #include <stdbool.h>
-#include <preemption.h>
-#include <arch/asm.h>
-
-#ifdef CONFIG_SMP
-
-typedef struct spinlock {
-	atomic_flag flag;
-
-#ifdef CONFIG_DEBUG_SPINLOCK
-	const char *name;
-#endif /* CONFIG_DEBUG_SPINLOCK */
-} spinlock_t;
-
-/*
- * SPINLOCK_DECLARE is to be used for dynamically allocated spinlocks,
- * where the lock gets initialized in run time.
- */
-#define SPINLOCK_DECLARE(lock_name)  spinlock_t lock_name
-#define SPINLOCK_EXTERN(lock_name)   extern spinlock_t lock_name
-
-/*
- * SPINLOCK_INITIALIZE and SPINLOCK_STATIC_INITIALIZE are to be used
- * for statically allocated spinlocks. They declare (either as global
- * or static) symbol and initialize the lock.
- */
-#ifdef CONFIG_DEBUG_SPINLOCK
-
-#define SPINLOCK_INITIALIZE_NAME(lock_name, desc_name) \
-	spinlock_t lock_name = { \
-		.name = desc_name, \
-		.flag = ATOMIC_FLAG_INIT \
-	}
-
-#define SPINLOCK_STATIC_INITIALIZE_NAME(lock_name, desc_name) \
-	static spinlock_t lock_name = { \
-		.name = desc_name, \
-		.flag = ATOMIC_FLAG_INIT \
-	}
-
-#define ASSERT_SPINLOCK(expr, lock) \
-	assert_verbose(expr, (lock)->name)
-
-#define spinlock_lock(lock)    spinlock_lock_debug((lock))
-#define spinlock_unlock(lock)  spinlock_unlock_debug((lock))
-
-#else /* CONFIG_DEBUG_SPINLOCK */
-
-#define SPINLOCK_INITIALIZE_NAME(lock_name, desc_name) \
-	spinlock_t lock_name = { \
-		.flag = ATOMIC_FLAG_INIT \
-	}
-
-#define SPINLOCK_STATIC_INITIALIZE_NAME(lock_name, desc_name) \
-	static spinlock_t lock_name = { \
-		.flag = ATOMIC_FLAG_INIT \
-	}
-
-#define ASSERT_SPINLOCK(expr, lock) \
-	assert(expr)
-
-/** Acquire spinlock
- *
- * @param lock  Pointer to spinlock_t structure.
- */
-_NO_TRACE static inline void spinlock_lock(spinlock_t *lock)
-{
-	preemption_disable();
-	while (atomic_flag_test_and_set_explicit(&lock->flag,
-	    memory_order_acquire))
-		;
-}
-
-/** Release spinlock
- *
- * @param lock  Pointer to spinlock_t structure.
- */
-_NO_TRACE static inline void spinlock_unlock(spinlock_t *lock)
-{
-	atomic_flag_clear_explicit(&lock->flag, memory_order_release);
-	preemption_enable();
-}
-
-#endif /* CONFIG_DEBUG_SPINLOCK */
-
-#define SPINLOCK_INITIALIZE(lock_name) \
-	SPINLOCK_INITIALIZE_NAME(lock_name, #lock_name)
-
-#define SPINLOCK_STATIC_INITIALIZE(lock_name) \
-	SPINLOCK_STATIC_INITIALIZE_NAME(lock_name, #lock_name)
-
-extern void spinlock_initialize(spinlock_t *, const char *);
-extern bool spinlock_trylock(spinlock_t *);
-extern void spinlock_lock_debug(spinlock_t *);
-extern void spinlock_unlock_debug(spinlock_t *);
-extern bool spinlock_locked(spinlock_t *);
-
-#ifdef CONFIG_DEBUG_SPINLOCK
+
+#include <arch/types.h>
+#include <assert.h>
+
+#define DEADLOCK_THRESHOLD  100000000
+
+#if defined(CONFIG_SMP) && defined(CONFIG_DEBUG_SPINLOCK)
 
 #include <log.h>
-
-#define DEADLOCK_THRESHOLD  100000000
 
 #define DEADLOCK_PROBE_INIT(pname)  size_t pname = 0
@@ -159,39 +67,100 @@
 #endif /* CONFIG_DEBUG_SPINLOCK */
 
-#else /* CONFIG_SMP */
-
-/* On UP systems, spinlocks are effectively left out. */
-
-/* Allow the use of spinlock_t as an incomplete type. */
-typedef struct spinlock spinlock_t;
-
-#define SPINLOCK_DECLARE(name)
-#define SPINLOCK_EXTERN(name)
-
-#define SPINLOCK_INITIALIZE(name)
-#define SPINLOCK_STATIC_INITIALIZE(name)
-
-#define SPINLOCK_INITIALIZE_NAME(name, desc_name)
-#define SPINLOCK_STATIC_INITIALIZE_NAME(name, desc_name)
-
-#define ASSERT_SPINLOCK(expr, lock)  assert(expr)
-
-#define spinlock_initialize(lock, name)
-
-#define spinlock_lock(lock)     preemption_disable()
-#define spinlock_trylock(lock)  ({ preemption_disable(); 1; })
-#define spinlock_unlock(lock)   preemption_enable()
-#define spinlock_locked(lock)	1
-#define spinlock_unlocked(lock)	1
-
-#define DEADLOCK_PROBE_INIT(pname)
-#define DEADLOCK_PROBE(pname, value)
-
-#endif /* CONFIG_SMP */
+typedef struct spinlock {
+#ifdef CONFIG_SMP
+	atomic_flag flag;
+
+#ifdef CONFIG_DEBUG_SPINLOCK
+	const char *name;
+#endif /* CONFIG_DEBUG_SPINLOCK */
+#endif
+} spinlock_t;
+
+/*
+ * SPINLOCK_DECLARE is to be used for dynamically allocated spinlocks,
+ * where the lock gets initialized in run time.
+ */
+#define SPINLOCK_DECLARE(lock_name)  spinlock_t lock_name
+#define SPINLOCK_EXTERN(lock_name)   extern spinlock_t lock_name
+
+#ifdef CONFIG_SMP
+#ifdef CONFIG_DEBUG_SPINLOCK
+#define SPINLOCK_INITIALIZER(desc_name) { .name = (desc_name), .flag = ATOMIC_FLAG_INIT }
+#else
+#define SPINLOCK_INITIALIZER(desc_name) { .flag = ATOMIC_FLAG_INIT }
+#endif
+#else
+#define SPINLOCK_INITIALIZER(desc_name) {}
+#endif
+
+/*
+ * SPINLOCK_INITIALIZE and SPINLOCK_STATIC_INITIALIZE are to be used
+ * for statically allocated spinlocks. They declare (either as global
+ * or static) symbol and initialize the lock.
+ */
+#define SPINLOCK_INITIALIZE_NAME(lock_name, desc_name) \
+	spinlock_t lock_name = SPINLOCK_INITIALIZER(desc_name)
+
+#define SPINLOCK_STATIC_INITIALIZE_NAME(lock_name, desc_name) \
+	static spinlock_t lock_name = SPINLOCK_INITIALIZER(desc_name)
+
+#if defined(CONFIG_SMP) && defined(CONFIG_DEBUG_SPINLOCK)
+#define ASSERT_SPINLOCK(expr, lock) assert_verbose(expr, (lock)->name)
+#else /* CONFIG_DEBUG_SPINLOCK */
+#define ASSERT_SPINLOCK(expr, lock) assert(expr)
+#endif /* CONFIG_DEBUG_SPINLOCK */
+
+#define SPINLOCK_INITIALIZE(lock_name) \
+	SPINLOCK_INITIALIZE_NAME(lock_name, #lock_name)
+
+#define SPINLOCK_STATIC_INITIALIZE(lock_name) \
+	SPINLOCK_STATIC_INITIALIZE_NAME(lock_name, #lock_name)
+
+#ifdef CONFIG_SMP
+
+extern void spinlock_initialize(spinlock_t *, const char *);
+extern bool spinlock_trylock(spinlock_t *);
+extern void spinlock_lock(spinlock_t *);
+extern void spinlock_unlock(spinlock_t *);
+extern bool spinlock_locked(spinlock_t *);
+
+#else
+
+#include <preemption.h>
+
+static inline void spinlock_initialize(spinlock_t *l, const char *name)
+{
+}
+
+static inline bool spinlock_trylock(spinlock_t *l)
+{
+	preemption_disable();
+	return true;
+}
+
+static inline void spinlock_lock(spinlock_t *l)
+{
+	preemption_disable();
+}
+
+static inline void spinlock_unlock(spinlock_t *l)
+{
+	preemption_enable();
+}
+
+static inline bool spinlock_locked(spinlock_t *l)
+{
+	return true;
+}
+
+#endif
 
 typedef struct {
-	SPINLOCK_DECLARE(lock);  /**< Spinlock */
-	bool guard;              /**< Flag whether ipl is valid */
-	ipl_t ipl;               /**< Original interrupt level */
+	spinlock_t lock;              /**< Spinlock */
+	bool guard;                   /**< Flag whether ipl is valid */
+	ipl_t ipl;                    /**< Original interrupt level */
+#ifdef CONFIG_DEBUG_SPINLOCK
+	_Atomic(struct cpu *) owner;  /**< Which cpu currently owns this lock */
+#endif
 } irq_spinlock_t;
 
@@ -199,8 +168,13 @@
 #define IRQ_SPINLOCK_EXTERN(lock_name)   extern irq_spinlock_t lock_name
 
-#ifdef CONFIG_SMP
-
 #define ASSERT_IRQ_SPINLOCK(expr, irq_lock) \
 	ASSERT_SPINLOCK(expr, &((irq_lock)->lock))
+
+#define IRQ_SPINLOCK_INITIALIZER(desc_name) \
+	{ \
+		.lock = SPINLOCK_INITIALIZER(desc_name), \
+		.guard = false, \
+		.ipl = 0, \
+	}
 
 /*
@@ -209,72 +183,9 @@
  * as global or static symbol) and initialize the lock.
  */
-#ifdef CONFIG_DEBUG_SPINLOCK
-
 #define IRQ_SPINLOCK_INITIALIZE_NAME(lock_name, desc_name) \
-	irq_spinlock_t lock_name = { \
-		.lock = { \
-			.name = desc_name, \
-			.flag = ATOMIC_FLAG_INIT \
-		}, \
-		.guard = false, \
-		.ipl = 0 \
-	}
+	irq_spinlock_t lock_name = IRQ_SPINLOCK_INITIALIZER(desc_name)
 
 #define IRQ_SPINLOCK_STATIC_INITIALIZE_NAME(lock_name, desc_name) \
-	static irq_spinlock_t lock_name = { \
-		.lock = { \
-			.name = desc_name, \
-			.flag = ATOMIC_FLAG_INIT \
-		}, \
-		.guard = false, \
-		.ipl = 0 \
-	}
-
-#else /* CONFIG_DEBUG_SPINLOCK */
-
-#define IRQ_SPINLOCK_INITIALIZE_NAME(lock_name, desc_name) \
-	irq_spinlock_t lock_name = { \
-		.lock = { \
-			.flag = ATOMIC_FLAG_INIT \
-		}, \
-		.guard = false, \
-		.ipl = 0 \
-	}
-
-#define IRQ_SPINLOCK_STATIC_INITIALIZE_NAME(lock_name, desc_name) \
-	static irq_spinlock_t lock_name = { \
-		.lock = { \
-			.flag = ATOMIC_FLAG_INIT \
-		}, \
-		.guard = false, \
-		.ipl = 0 \
-	}
-
-#endif /* CONFIG_DEBUG_SPINLOCK */
-
-#else /* CONFIG_SMP */
-
-/*
- * Since the spinlocks are void on UP systems, we also need
- * to have a special variant of interrupts-disabled spinlock
- * macros which take this into account.
- */
-
-#define ASSERT_IRQ_SPINLOCK(expr, irq_lock) \
-	ASSERT_SPINLOCK(expr, NULL)
-
-#define IRQ_SPINLOCK_INITIALIZE_NAME(lock_name, desc_name) \
-	irq_spinlock_t lock_name = { \
-		.guard = false, \
-		.ipl = 0 \
-	}
-
-#define IRQ_SPINLOCK_STATIC_INITIALIZE_NAME(lock_name, desc_name) \
-	static irq_spinlock_t lock_name = { \
-		.guard = false, \
-		.ipl = 0 \
-	}
-
-#endif /* CONFIG_SMP */
+	static irq_spinlock_t lock_name = IRQ_SPINLOCK_INITIALIZER(desc_name)
 
 #define IRQ_SPINLOCK_INITIALIZE(lock_name) \
Index: kernel/generic/include/synch/waitq.h
===================================================================
--- kernel/generic/include/synch/waitq.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/synch/waitq.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -41,9 +41,4 @@
 #include <adt/list.h>
 
-typedef enum {
-	WAKEUP_FIRST = 0,
-	WAKEUP_ALL
-} wakeup_mode_t;
-
 /** Wait queue structure.
  *
@@ -57,31 +52,34 @@
 
 	/**
-	 * Number of waitq_wakeup() calls that didn't find a thread to wake up.
-	 *
+	 * If negative, number of wakeups that are to be ignored (necessary for futex operation).
+	 * If positive, number of wakeups that weren't able to wake a thread.
 	 */
-	int missed_wakeups;
-
-	/** Number of wakeups that need to be ignored due to futex timeout. */
-	int ignore_wakeups;
+	int wakeup_balance;
 
 	/** List of sleeping threads for which there was no missed_wakeup. */
 	list_t sleepers;
+
+	bool closed;
 } waitq_t;
 
-#define waitq_sleep(wq) \
-	waitq_sleep_timeout((wq), SYNCH_NO_TIMEOUT, SYNCH_FLAGS_NONE, NULL)
+typedef struct wait_guard {
+	ipl_t ipl;
+} wait_guard_t;
 
 struct thread;
 
 extern void waitq_initialize(waitq_t *);
-extern errno_t waitq_sleep_timeout(waitq_t *, uint32_t, unsigned int, bool *);
-extern ipl_t waitq_sleep_prepare(waitq_t *);
-extern errno_t waitq_sleep_timeout_unsafe(waitq_t *, uint32_t, unsigned int, bool *);
-extern void waitq_sleep_finish(waitq_t *, bool, ipl_t);
-extern void waitq_wakeup(waitq_t *, wakeup_mode_t);
-extern void _waitq_wakeup_unsafe(waitq_t *, wakeup_mode_t);
-extern void waitq_interrupt_sleep(struct thread *);
-extern int waitq_count_get(waitq_t *);
-extern void waitq_count_set(waitq_t *, int val);
+extern void waitq_initialize_with_count(waitq_t *, int);
+extern errno_t waitq_sleep(waitq_t *);
+extern errno_t _waitq_sleep_timeout(waitq_t *, uint32_t, unsigned int);
+extern errno_t waitq_sleep_timeout(waitq_t *, uint32_t);
+extern wait_guard_t waitq_sleep_prepare(waitq_t *);
+extern errno_t waitq_sleep_unsafe(waitq_t *, wait_guard_t);
+extern errno_t waitq_sleep_timeout_unsafe(waitq_t *, uint32_t, unsigned int, wait_guard_t);
+
+extern void waitq_wake_one(waitq_t *);
+extern void waitq_wake_all(waitq_t *);
+extern void waitq_signal(waitq_t *);
+extern void waitq_close(waitq_t *);
 
 #endif
Index: kernel/generic/include/time/timeout.h
===================================================================
--- kernel/generic/include/time/timeout.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/time/timeout.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -42,11 +42,12 @@
 typedef void (*timeout_handler_t)(void *arg);
 
+typedef uint64_t deadline_t;
+#define DEADLINE_NEVER ((deadline_t) UINT64_MAX)
+
 typedef struct {
-	IRQ_SPINLOCK_DECLARE(lock);
-
-	/** Link to the list of active timeouts on CURRENT->cpu */
+	/** Link to the list of active timeouts on timeout->cpu */
 	link_t link;
-	/** Timeout will be activated in this amount of clock() ticks. */
-	uint64_t ticks;
+	/** Timeout will be activated when current clock tick reaches this value. */
+	deadline_t deadline;
 	/** Function that will be called on timeout activation. */
 	timeout_handler_t handler;
@@ -55,12 +56,16 @@
 	/** On which processor is this timeout registered. */
 	cpu_t *cpu;
+	/** Used to synchronize with the handler callback. */
+	atomic_bool finished;
 } timeout_t;
 
 #define us2ticks(us)  ((uint64_t) (((uint32_t) (us) / (1000000 / HZ))))
 
+extern deadline_t timeout_deadline_in_usec(uint32_t us);
+
 extern void timeout_init(void);
 extern void timeout_initialize(timeout_t *);
-extern void timeout_reinitialize(timeout_t *);
 extern void timeout_register(timeout_t *, uint64_t, timeout_handler_t, void *);
+extern void timeout_register_deadline(timeout_t *, deadline_t, timeout_handler_t, void *);
 extern bool timeout_unregister(timeout_t *);
 
Index: kernel/generic/meson.build
===================================================================
--- kernel/generic/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -36,8 +36,17 @@
 
 generic_src += files(
-	'src/adt/bitmap.c',
-	'src/adt/hash_table.c',
-	'src/adt/list.c',
-	'src/adt/odict.c',
+	'common/adt/bitmap.c',
+	'common/adt/hash_table.c',
+	'common/adt/list.c',
+	'common/adt/odict.c',
+	'common/printf/printf_core.c',
+	'common/stdc/calloc.c',
+	'common/stdc/ctype.c',
+	'common/stdc/mem.c',
+	'common/gsort.c',
+	'common/str.c',
+	'common/str_error.c',
+	'common/strtol.c',
+
 	'src/cap/cap.c',
 	'src/console/chardev.c',
@@ -46,8 +55,12 @@
 	'src/cpu/cpu_mask.c',
 	'src/ddi/irq.c',
-	'src/debug/debug.c',
+	'src/debug/line.c',
+	'src/debug/names.c',
 	'src/debug/panic.c',
+	'src/debug/profile.c',
+	'src/debug/sections.c',
 	'src/debug/stacktrace.c',
 	'src/debug/symtab.c',
+	'src/debug/util.c',
 	'src/ipc/event.c',
 	'src/ipc/ipc.c',
@@ -66,13 +79,8 @@
 	'src/ipc/sysipc_ops.c',
 	'src/lib/elf.c',
-	'src/lib/gsort.c',
 	'src/lib/halt.c',
 	'src/lib/mem.c',
-	'src/lib/memfnc.c',
 	'src/lib/ra.c',
 	'src/lib/rd.c',
-	'src/lib/str.c',
-	'src/lib/strtol.c',
-	'src/lib/str_error.c',
 	'src/lib/ubsan.c',
 	'src/log/log.c',
@@ -87,7 +95,5 @@
 	'src/mm/malloc.c',
 	'src/mm/reserve.c',
-	'src/preempt/preemption.c',
 	'src/printf/printf.c',
-	'src/printf/printf_core.c',
 	'src/printf/snprintf.c',
 	'src/printf/vprintf.c',
@@ -101,4 +107,5 @@
 	'src/smp/smp.c',
 	'src/synch/condvar.c',
+	'src/synch/irq_spinlock.c',
 	'src/synch/mutex.c',
 	'src/synch/semaphore.c',
Index: kernel/generic/src/cap/cap.c
===================================================================
--- kernel/generic/src/cap/cap.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/cap/cap.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -125,5 +125,5 @@
 }
 
-static hash_table_ops_t caps_ops = {
+static const hash_table_ops_t caps_ops = {
 	.hash = caps_hash,
 	.key_hash = caps_key_hash,
@@ -347,5 +347,5 @@
 			/* Hand over cap's reference to kobj */
 			kobj = cap->kobject;
-			if (!mutex_trylock(&kobj->caps_list_lock)) {
+			if (mutex_trylock(&kobj->caps_list_lock) != EOK) {
 				mutex_unlock(&task->cap_info->lock);
 				kobj = NULL;
Index: kernel/generic/src/console/chardev.c
===================================================================
--- kernel/generic/src/console/chardev.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/console/chardev.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -52,5 +52,5 @@
 {
 	indev->name = name;
-	waitq_initialize(&indev->wq);
+	semaphore_initialize(&indev->wq, 0);
 	irq_spinlock_initialize(&indev->lock, "chardev.indev.lock");
 	indev->counter = 0;
@@ -81,5 +81,5 @@
 	/* Index modulo size of buffer */
 	indev->index = indev->index % INDEV_BUFLEN;
-	waitq_wakeup(&indev->wq, WAKEUP_FIRST);
+	semaphore_up(&indev->wq);
 	irq_spinlock_unlock(&indev->lock, true);
 }
@@ -115,5 +115,5 @@
 	}
 
-	waitq_sleep(&indev->wq);
+	semaphore_down(&indev->wq);
 	irq_spinlock_lock(&indev->lock, true);
 	char32_t ch = indev->buffer[(indev->index - indev->counter) %
Index: kernel/generic/src/console/cmd.c
===================================================================
--- kernel/generic/src/console/cmd.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/console/cmd.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -229,4 +229,14 @@
 };
 
+/* Data and methods for 'printbench' command. */
+static int cmd_printbench(cmd_arg_t *argv);
+
+static cmd_info_t printbench_info = {
+	.name = "printbench",
+	.description = "Run a printing benchmark.",
+	.func = cmd_printbench,
+	.argc = 0,
+};
+
 #endif /* CONFIG_TEST */
 
@@ -613,4 +623,5 @@
 	&test_info,
 	&bench_info,
+	&printbench_info,
 #endif
 #ifdef CONFIG_UDEBUG
@@ -993,7 +1004,6 @@
 			printf("cpu%u: ", i);
 			thread_wire(thread, &cpus[i]);
-			thread_ready(thread);
+			thread_start(thread);
 			thread_join(thread);
-			thread_detach(thread);
 		} else
 			printf("Unable to create thread for cpu%u\n", i);
@@ -1582,4 +1592,58 @@
 }
 
+int cmd_printbench(cmd_arg_t *argv)
+{
+	int cnt = 20;
+
+	uint64_t *data = malloc(sizeof(uint64_t) * cnt);
+	if (data == NULL) {
+		printf("Error allocating memory for statistics\n");
+		return false;
+	}
+
+	for (int i = 0; i < cnt; i++) {
+		/*
+		 * Update and read thread accounting
+		 * for benchmarking
+		 */
+		irq_spinlock_lock(&TASK->lock, true);
+		uint64_t ucycles0, kcycles0;
+		task_get_accounting(TASK, &ucycles0, &kcycles0);
+		irq_spinlock_unlock(&TASK->lock, true);
+
+		/* Execute the test */
+		for (int j = 0; j < 20; j++) {
+			printf("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789ěščřžýáíéú!@#$%%^&*(){}+\n");
+			printf("ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789ěščřžýáíéú!@#$%%^&*(){}+abcdefghijklmnopqrstuvwxyz\n");
+			printf("0123456789ěščřžýáíéú!@#$%%^&*(){}+abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ\n");
+		}
+
+		/* Update and read thread accounting */
+		irq_spinlock_lock(&TASK->lock, true);
+		uint64_t ucycles1, kcycles1;
+		task_get_accounting(TASK, &ucycles1, &kcycles1);
+		irq_spinlock_unlock(&TASK->lock, true);
+
+		data[i] = ucycles1 - ucycles0 + kcycles1 - kcycles0;
+	}
+
+	printf("\n");
+
+	uint64_t cycles;
+	char suffix;
+	uint64_t sum = 0;
+
+	for (int i = 0; i < cnt; i++) {
+		sum += data[i];
+	}
+
+	order_suffix(sum / (uint64_t) cnt, &cycles, &suffix);
+	printf("Average\t\t%" PRIu64 "%c\n", cycles, suffix);
+
+	free(data);
+
+	return true;
+}
+
 #endif
 
Index: kernel/generic/src/console/console.c
===================================================================
--- kernel/generic/src/console/console.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/console/console.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -243,55 +243,4 @@
 }
 
-/** Get string from input character device.
- *
- * Read characters from input character device until first occurrence
- * of newline character.
- *
- * @param indev  Input character device.
- * @param buf    Buffer where to store string terminated by NULL.
- * @param buflen Size of the buffer.
- *
- * @return Number of characters read.
- *
- */
-size_t gets(indev_t *indev, char *buf, size_t buflen)
-{
-	size_t offset = 0;
-	size_t count = 0;
-	buf[offset] = 0;
-
-	char32_t ch;
-	while ((ch = indev_pop_character(indev)) != '\n') {
-		if (ch == '\b') {
-			if (count > 0) {
-				/* Space, backspace, space */
-				putuchar('\b');
-				putuchar(' ');
-				putuchar('\b');
-
-				count--;
-				offset = str_lsize(buf, count);
-				buf[offset] = 0;
-			}
-		}
-
-		if (chr_encode(ch, buf, &offset, buflen - 1) == EOK) {
-			putuchar(ch);
-			count++;
-			buf[offset] = 0;
-		}
-	}
-
-	return count;
-}
-
-/** Get character from input device & echo it to screen */
-char32_t getc(indev_t *indev)
-{
-	char32_t ch = indev_pop_character(indev);
-	putuchar(ch);
-	return ch;
-}
-
 void kio_update(void *event)
 {
Index: kernel/generic/src/console/kconsole.c
===================================================================
--- kernel/generic/src/console/kconsole.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/console/kconsole.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -85,4 +85,6 @@
 SPINLOCK_INITIALIZE(cmd_lock);  /**< Lock protecting command list. */
 LIST_INITIALIZE(cmd_list);      /**< Command list. */
+
+#define MAX_SYMBOL_NAME 64
 
 static char32_t history[KCONSOLE_HISTORY][MAX_CMDLINE] = { };
@@ -597,5 +599,5 @@
 		/* It's a number - convert it */
 		uint64_t value;
-		char *end;
+		const char *end;
 		errno_t rc = str_uint64_t(text, &end, 0, false, &value);
 		if (end != text + len)
Index: kernel/generic/src/cpu/cpu.c
===================================================================
--- kernel/generic/src/cpu/cpu.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/cpu/cpu.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -45,5 +45,5 @@
 #include <config.h>
 #include <panic.h>
-#include <mem.h>
+#include <memw.h>
 #include <adt/list.h>
 #include <stdio.h>
@@ -81,8 +81,11 @@
 				panic("Cannot allocate CPU stack.");
 
-			cpus[i].stack = (uint8_t *) PA2KA(stack_phys);
+			cpus[i].local.stack = (uint8_t *) PA2KA(stack_phys);
 			cpus[i].id = i;
 
-			irq_spinlock_initialize(&cpus[i].lock, "cpus[].lock");
+#ifdef CONFIG_FPU_LAZY
+			irq_spinlock_initialize(&cpus[i].fpu_lock, "cpus[].fpu_lock");
+#endif
+			irq_spinlock_initialize(&cpus[i].tlb_lock, "cpus[].tlb_lock");
 
 			for (unsigned int j = 0; j < RQ_COUNT; j++) {
@@ -101,8 +104,8 @@
 	CPU->tlb_active = true;
 
-	CPU->idle = false;
-	CPU->last_cycle = get_cycle();
-	CPU->idle_cycles = 0;
-	CPU->busy_cycles = 0;
+	CPU_LOCAL->idle = false;
+	CPU_LOCAL->last_cycle = get_cycle();
+	CPU->idle_cycles = ATOMIC_TIME_INITIALIZER();
+	CPU->busy_cycles = ATOMIC_TIME_INITIALIZER();
 
 	cpu_identify();
Index: kernel/generic/src/ddi/ddi.c
===================================================================
--- kernel/generic/src/ddi/ddi.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/ddi/ddi.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -54,5 +54,5 @@
 #include <align.h>
 #include <errno.h>
-#include <mem.h>
+#include <memw.h>
 #include <trace.h>
 #include <bitops.h>
@@ -336,23 +336,19 @@
 		return EPERM;
 
-	irq_spinlock_lock(&tasks_lock, true);
-
 	task_t *task = task_find_by_id(id);
 
-	if ((!task) || (!container_check(CONTAINER, task->container))) {
-		/*
-		 * There is no task with the specified ID
-		 * or the task belongs to a different security
-		 * context.
-		 */
-		irq_spinlock_unlock(&tasks_lock, true);
+	if (!task)
 		return ENOENT;
-	}
-
-	/* Lock the task and release the lock protecting tasks dictionary. */
-	irq_spinlock_exchange(&tasks_lock, &task->lock);
-	errno_t rc = ddi_iospace_enable_arch(task, ioaddr, size);
+
+	errno_t rc = ENOENT;
+
+	irq_spinlock_lock(&task->lock, true);
+
+	/* Check that the task belongs to the correct security context. */
+	if (container_check(CONTAINER, task->container))
+		rc = ddi_iospace_enable_arch(task, ioaddr, size);
+
 	irq_spinlock_unlock(&task->lock, true);
-
+	task_release(task);
 	return rc;
 }
@@ -377,23 +373,19 @@
 		return EPERM;
 
-	irq_spinlock_lock(&tasks_lock, true);
-
 	task_t *task = task_find_by_id(id);
 
-	if ((!task) || (!container_check(CONTAINER, task->container))) {
-		/*
-		 * There is no task with the specified ID
-		 * or the task belongs to a different security
-		 * context.
-		 */
-		irq_spinlock_unlock(&tasks_lock, true);
+	if (!task)
 		return ENOENT;
-	}
-
-	/* Lock the task and release the lock protecting tasks dictionary. */
-	irq_spinlock_exchange(&tasks_lock, &task->lock);
-	errno_t rc = ddi_iospace_disable_arch(task, ioaddr, size);
+
+	errno_t rc = ENOENT;
+
+	irq_spinlock_lock(&task->lock, true);
+
+	/* Check that the task belongs to the correct security context. */
+	if (container_check(CONTAINER, task->container))
+		rc = ddi_iospace_disable_arch(task, ioaddr, size);
+
 	irq_spinlock_unlock(&task->lock, true);
-
+	task_release(task);
 	return rc;
 }
Index: kernel/generic/src/ddi/irq.c
===================================================================
--- kernel/generic/src/ddi/irq.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/ddi/irq.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -47,5 +47,5 @@
 #include <console/console.h>
 #include <interrupt.h>
-#include <mem.h>
+#include <memw.h>
 #include <arch.h>
 
@@ -77,5 +77,5 @@
 static bool irq_ht_key_equal(const void *, const ht_link_t *);
 
-static hash_table_ops_t irq_ht_ops = {
+static const hash_table_ops_t irq_ht_ops = {
 	.hash = irq_ht_hash,
 	.key_hash = irq_ht_key_hash,
